@echo off
pushd "%~dp0"
rem Define the possible Python executables
set PYTHON_EXECUTABLES=py python3 python

rem Check if requirements.txt exists
if not exist requirements.txt (
    echo requirements.txt not found.
    exit /b
)

rem Loop through each Python executable and check if it's available
set PYTHON_EXE=
for %%i in (%PYTHON_EXECUTABLES%) do (
    where %%i >nul 2>&1
    if not errorlevel 1 (
        set PYTHON_EXE=%%i
        goto :found_python
    )
)

rem If no Python executable is found, exit
if "%PYTHON_EXE%"=="" (
    echo No Python executable found.
    exit /b
)

:found_python

rem Install Python packages from requirements.txt
%PYTHON_EXE% -m pip install -r requirements.txt

rem Check if installation was successful
if errorlevel 1 (
    echo Failed to install Python packages from requirements.txt.
    exit /b
)

rem Run proxy-server.py
"%PYTHON_EXE%" proxy-server.py