import http.server
import urllib.request
import urllib.parse
import ssl
import os
import sys
import re
import json
import socket
import time
import threading
import pydivert
import requests


global matchmaking_server
global trn_server

matchmaking_server = None
trn_server = None

TEKKENMODS_AUTH_URL = "https://tekkenmods.com/cosmos-api/get_udp_servers"
AUTH_TOKEN = None

def RTT(host, port, timeout, server_type):
    try:
        socks_params = (host, port)
        with socket.socket(socket.AF_INET, socket.SOCK_DGRAM) as sock:
            sock.settimeout(timeout)
            sock.connect(socks_params)
            t1 = time.time()
            data = AUTH_TOKEN.encode() + b':' + server_type.encode() + b':1.1.1.1.bc.googleusercontent.com'
            sock.sendall(data)
            data = sock.recv(len(data))
            t2 = time.time()

            return t2-t1
    except:
        return 5 # Just some random high value

def spoof_udp(packet):
    global matchmaking_server
    if matchmaking_server != None:
        if packet.dst_addr == matchmaking_server['origin']:
            packet.dst_addr =  matchmaking_server['destination']
            packet.dst_port = matchmaking_server['port']
        
    global trn_server
    if trn_server != None:
        if packet.dst_addr == trn_server['origin']:
            packet.dst_addr =  trn_server['destination']
            packet.dst_port = trn_server['port']

    #if trn_server != None:
    #    if packet.dns.qry_name == trn_server['origin']:
    #        packet.dns.resp_addr = trn_server['destination']
    #        packet.dns.resp_type = pydivert.DNSRecordType.A
    #        packet.dst_port = trn_server['port']

    return packet

def send_udp_packet(ip, port, data):
    # Create a UDP socket
    with socket.socket(socket.AF_INET, socket.SOCK_DGRAM) as sock:
        # Send data
        sock.sendto(data.encode(), (ip, port))
        print(f"Sent UDP packet to {ip}:{port} with data: {data}")

class ReverseProxyHandler(http.server.BaseHTTPRequestHandler):
    def do_GET(self):
        self.proxy_request()

    def do_POST(self):
        content_length = int(self.headers['Content-Length'])
        post_data = self.rfile.read(content_length)
        self.proxy_request(post_data)

    def proxy_request(self, data=None):
        global AUTH_TOKEN
        global matchmaking_server
        global trn_server
        # Determine the target host based on the incoming request's host header
        host = self.headers['Host']
        if host == 'cosmos.channel.or.jp':
            target_host = 'cosmos.tekkenmods.com'
        elif host == 'polaris.cosmos.channel.or.jp':
            target_host = 'polaris-cosmos.tekkenmods.com'
        else:
            self.send_error(404, 'Not Found')
            return

        # Construct the target URL
        url = 'https://' + target_host + self.path

        try:
            headers = {'User-Agent': 'Pola/269858 (Cosmos 0.3.0; W64)',
                       'Content-Type': self.headers.get('Content-Type', 'application/x-www-form-urlencoded')}
            req = urllib.request.Request(url, headers=headers, data=data)

            with urllib.request.urlopen(req) as response:
                content = response.read()

                #content = re.sub(rb'"serverHost":"[^"]+"', b'"serverHost":"127.0.0.1"', content)

                # check for google cloud service data connection
                
                start_index = data.find(b'{"serverType":"MM"')
                if start_index != -1:
                    end_index = content.find(b'\xa0', start_index)
                    if end_index != -1:  # If byte \xa0 is found
                        # Extract the substring containing JSON data
                        json_data = content[start_index-len(b'{"serverType":"MM"')-2:end_index]
                        # Convert the JSON data to Python dictionary
                        try:
                            parsed_json = json.loads(json_data)
                            print(parsed_json['serverHost'])
                            matchmaking_server = { 'origin': socket.getaddrinfo(parsed_json['serverHost'], parsed_json['serverPort'], family=socket.AF_INET, proto=socket.SOCK_DGRAM)[0][4][0], 
                                                  'destination': best_mm_server['ipAddress'], 'port': parsed_json['serverPort'] }
                            # Extract ip address
                            #ip_pattern = r'\b(?:[0-9]{1,3}\.){3}[0-9]{1,3}\b'
                            #ip_matches = re.findall(ip_pattern, parsed_json['serverHost'])

                            #ip_match = ip_matches[0].encode('ascii')
                            #new_loopback_subdomain = (('x' * len(ip_match)) + '.bc.googleusercontent.com').encode('ascii')
                            #print(new_loopback_subdomain)
                            #content = re.sub(parsed_json['serverHost'].encode('ascii'), new_loopback_subdomain, content)
                            send_udp_packet(best_mm_server['ipAddress'], parsed_json['serverPort'], AUTH_TOKEN + ':MM:' + parsed_json['serverHost'])
                            time.sleep(0.5)
                        except json.JSONDecodeError as e:
                            print("Error decoding JSON:", e)

                start_index = data.find(b'{"serverType":"TRN"')
                if start_index != -1:
                    end_index = content.find(b'\xa0', start_index)
                    if end_index != -1:  # If byte \xa0 is found
                        # Extract the substring containing JSON data
                        json_data = content[start_index-len(b'{"serverType":"TRN"')-1:end_index]
                        print(json_data)
                        # Convert the JSON data to Python dictionary
                        try:
                            parsed_json = json.loads(json_data)
                            print(parsed_json['serverHost'])

                            # Extract ip address
                            #ip_pattern = r'\b(?:[0-9]{1,3}\.){3}[0-9]{1,3}\b'
                            #ip_matches = re.findall(ip_pattern, parsed_json['serverHost'])
                            trn_server = { 'origin': socket.getaddrinfo(parsed_json['serverHost'], parsed_json['serverPort'], family=socket.AF_INET, proto=socket.SOCK_DGRAM)[0][4][0],
                                            'port': parsed_json['serverPort'],
                                            'destination': best_trn_server['ipAddress'] }
                            #ip_match = ip_matches[0].encode('ascii')
                            #new_loopback_subdomain = (('x' * len(ip_match)) + '.tn.googleusercontent.com').encode('ascii')
                            #print(new_loopback_subdomain)
                            #content = re.sub(parsed_json['serverHost'].encode('ascii'), new_loopback_subdomain, content)
                            send_udp_packet(parsed_json['serverHost'], parsed_json['serverPort'],  AUTH_TOKEN + ':TRN:' + parsed_json['serverHost'])
                            time.sleep(0.5)
                        except json.JSONDecodeError as e:
                            print("Error decoding JSON:", e)
                
                print(content)
                self.send_response(response.status)
                for header, value in response.headers.items():
                    self.send_header(header, value)
                self.end_headers()
                self.wfile.write(content)
        except urllib.error.HTTPError as e:
            self.send_error(e.code, e.reason)
        except urllib.error.URLError as e:
            self.send_error(502, 'Bad Gateway', str(e.reason))


def generate_ssl_context():
    # Create a temporary directory to store the generated certificate files
    temp_dir = 'temp_ssl_cert'
    # os.makedirs(temp_dir, exist_ok=True)

    # Generate SSL certificate and private key for the mapped domains
    # for domain in ['cosmos.channel.or.jp', 'polaris.cosmos.channel.or.jp']:
    #    cert_file = os.path.join(temp_dir, domain + '.pem')
    #    key_file = os.path.join(temp_dir, domain + '.key')
    # silly windows, doesn't generate a .pem file because of some -subj nonsense path conversion on msys
    #    ssl_cmd = f"openssl req -x509 -nodes -newkey rsa:2048 -keyout \"{key_file}\" -out \"{cert_file}\" -days 365 -subj '//SKIP=skip/CN={domain}'"
    #    print(ssl_cmd)
    #
    #    os.system(ssl_cmd)

    # Create SSL context
    print(os.path.abspath(os.path.join(temp_dir, 'cosmos.channel.or.jp.pem')))
    ssl_context = ssl.create_default_context(ssl.Purpose.CLIENT_AUTH)
    ssl_context.load_cert_chain(certfile=os.path.abspath(os.path.join(temp_dir, 'cosmos.channel.or.jp.pem')),
                                keyfile=os.path.abspath(os.path.join(temp_dir, 'cosmos.channel.or.jp.key')))

    return ssl_context

def run_reverse_proxy(server_class=http.server.HTTPServer, handler_class=ReverseProxyHandler, port=443):
    server_address = ('', port)
    httpd = server_class(server_address, handler_class)
    ssl_context = generate_ssl_context()
    httpd.socket = ssl_context.wrap_socket(httpd.socket, server_side=True)
    print(f"Starting reverse proxy server on port {port}...")
    httpd.serve_forever()

def spoof():
    try:
        with pydivert.WinDivert("outbound and udp.PayloadLength > 0") as w:
            for packet in w:
                packet = spoof_udp(packet)
                w.send(packet) 
    except KeyboardInterrupt:
        return

def main():
    matchmaking_server = { 'origin': None, 'destination': None, 'port': None }
    trn_server = { 'origin': None, 'destination': None, 'port': None }
    spoof_thread = threading.Thread(target=spoof)
    spoof_thread.daemon = True
    spoof_thread.start()
    run_reverse_proxy()

if __name__ == '__main__':
    retry_attempts = 5
    with open('settings.json') as f:
        data = json.load(f)
        AUTH_TOKEN = data['auth_token']

    retry_count = 0
    while retry_count < retry_attempts:
        response = requests.get(TEKKENMODS_AUTH_URL, headers={"Authorization": f"Bearer {AUTH_TOKEN}"}, verify=True)

        # Initialize best MM and TRN servers with None and a very large RTT
        best_mm_server = None
        best_mm_rtt = float('inf')
        best_trn_server = None
        best_trn_rtt = float('inf')
        
        if response.status_code == 200:
            json_data = response.json()
            print(json_data)
            mm_servers = json_data.get('mm', [])
            trn_servers = json_data.get('trn', [])

            # Iterate over MM servers
            for server in mm_servers:
                rtt = RTT(server['ipAddress'], 7100, 1, server['serverType'])  # Adjust port and timeout as needed
                if rtt < best_mm_rtt:
                    best_mm_rtt = rtt
                    best_mm_server = server

            # Iterate over TRN servers
            for server in trn_servers:
                rtt = RTT(server['ipAddress'], 7100, 1, server['serverType'])  # Adjust port and timeout as needed
                if rtt < best_trn_rtt:
                    best_trn_rtt = rtt
                    best_trn_server = server
            
            if best_mm_server is None or best_trn_server is None:
                print("Failed to find appropriate servers. Retrying...")
                retry_count += 1
            else:
                print(f"Best MM Server: {best_mm_server} with ping {best_mm_rtt}")
                print(f"Best TRN Server: {best_trn_server} with ping {best_trn_rtt}")
                break  # Exit the loop if appropriate servers are found
        else:
            print("Invalid token provided!")
            sys.exit(1)
    else:
        print("Exceeded maximum retry attempts. Exiting...")
        sys.exit(1)
    main()